diff --git a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
index 50ed053cb..183ece731 100644
--- a/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
+++ b/game/client/src/main/java/net/minecraft/client/render/terrain/ChunkRendererMultiDraw.java
@@ -4,9 +4,8 @@ import java.util.HashSet;
 import java.util.List;
 import java.util.Set;
 
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.RenderBlocks;
 import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.culling.CameraFrustum;
@@ -61,9 +60,7 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 		
 		final int cacheRadius = 1;
 		final ChunkCache chunkCache = new ChunkCache(world, minX - cacheRadius, minY - cacheRadius, minZ - cacheRadius, maxX + cacheRadius, maxY + cacheRadius, maxZ + cacheRadius);
-		final RenderBlocks renderBlocks = new RenderBlocks(chunkCache);
-		BlockModel.setRenderBlocks(renderBlocks);
-		
+
 		TessellatorStandard tessellator = (TessellatorStandard) Tessellator.instance;
 		for(int renderPass = 0; renderPass < renderPassCount; renderPass++) {
 			boolean needsMoreRenderPasses = false;
@@ -93,8 +90,8 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 							tessellator.setTextureUV(0.0, 0.0);
 						}
 						if(renderPass == 0 && Blocks.isEntityTile[blockId]) {
-							final TileEntity tileentity = chunkCache.getBlockEntity(x, y, z);
-							if(BlockEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
+							final TileEntity tileentity = chunkCache.getTileEntity(x, y, z);
+							if(TileEntityRenderDispatcher.instance.hasRenderer(tileentity)) {
 								renderableBlockEntities.add(tileentity);
 							}
 						}
@@ -106,7 +103,7 @@ public class ChunkRendererMultiDraw extends ChunkRenderer {
 							continue;
 						}
 						
-						hasRenderedBlock |= renderBlock(tessellator, renderBlocks, model, x, y, z);
+						hasRenderedBlock |= renderBlock(tessellator, world, model, x, y, z);
 					}
 				}
 			}
diff --git a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
index 51ba2a7a7..b24352f5f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
+++ b/game/client/src/main/java/net/minecraft/client/render/texturepack/TexturePackList.java
@@ -4,6 +4,8 @@ import com.mojang.logging.LogUtils;
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.gui.keyboard.KeyboardLayout;
 import net.minecraft.client.render.Font;
+import net.minecraft.client.render.block.model.BlockModelDispatcher;
+import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.sound.SoundRepository;
 import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
@@ -97,7 +99,8 @@ public class TexturePackList
 		}
 		mc.textureManager.updateDynamicTextures(false);
 		SoundRepository.reload();
-
+		BlockModelDispatcher.getInstance().reload();
+		ItemModelDispatcher.getInstance().reload();
 		KeyboardLayout.defaultLayout = new KeyboardLayout();
 	}
 
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRenderer.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
similarity index 78%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRenderer.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
index a85f63e74..4d41ee199 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRenderer.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRenderer.java
@@ -1,8 +1,8 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.render.Font;
 import net.minecraft.client.render.TextureManager;
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.block.entity.TileEntity;
 import net.minecraft.core.world.World;
@@ -23,7 +23,7 @@ public abstract class TileEntityRenderer<T extends TileEntity>
         textureManager.bindTexture(textureManager.loadTexture(texturePath));
     }
 
-    public void setRenderDispatcher(BlockEntityRenderDispatcher renderDispatcher)
+    public void setRenderDispatcher(TileEntityRenderDispatcher renderDispatcher)
     {
         this.renderDispatcher = renderDispatcher;
     }
@@ -38,5 +38,5 @@ public abstract class TileEntityRenderer<T extends TileEntity>
         return renderDispatcher.getFont();
     }
 
-    protected BlockEntityRenderDispatcher renderDispatcher;
+    protected TileEntityRenderDispatcher renderDispatcher;
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
similarity index 98%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
index e157aa28c..3e5d6e048 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlag.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlag.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.FlagRenderer;
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
similarity index 52%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
index e14d148ce..739e5400a 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererFlowerJar.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererFlowerJar.java
@@ -1,18 +1,17 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
+import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.Lighting;
 import net.minecraft.client.render.LightmapHelper;
-import net.minecraft.client.render.RenderBlocks;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
-import net.minecraft.core.Global;
 import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.block.entity.TileEntityFlowerJar;
 import net.minecraft.core.enums.LightLayer;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.WorldSource;
 import org.lwjgl.opengl.GL11;
 
 import static org.lwjgl.opengl.GL11.GL_BLEND;
@@ -20,12 +19,7 @@ import static org.lwjgl.opengl.GL11.GL_ONE_MINUS_SRC_ALPHA;
 import static org.lwjgl.opengl.GL11.GL_SRC_ALPHA;
 
 public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFlowerJar> {
-    private RenderBlocks renderBlocks;
-    @Override
-    public void onWorldChanged(World world)
-    {
-        renderBlocks = new RenderBlocks(world);
-    }
+
     @Override
     public void doRender(Tessellator tessellator, TileEntityFlowerJar tileEntity, double x, double y, double z, float renderPartialTicks) {
         GL11.glPushMatrix();
@@ -36,29 +30,19 @@ public class TileEntityRendererFlowerJar extends TileEntityRenderer<TileEntityFl
             float scaleValue = 0.75F;
             GL11.glScalef(scaleValue, scaleValue, scaleValue);
             GL11.glTranslatef(0.66F, 0.75F, 0.66F);
-            float lightLevel = renderBlocks.getBlockBrightness(tileEntity.worldObj, tileEntity.x, tileEntity.y, tileEntity.z);
-            if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
-            BlockModel.setRenderBlocks(renderBlocks);
-            Integer lmc = null;
-            if (LightmapHelper.isLightmapEnabled()){
-                if (Global.accessor.isFullbrightEnabled()){
-                    lmc = LightmapHelper.getOverbrightLightmapCoord(tileEntity.worldObj.getSavedLightValue(LightLayer.Sky, tileEntity.x, tileEntity.y, tileEntity.z));
-                } else {
-                    lmc = tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, 0);
-                }
-                lightLevel = 1f;
-            }
             GL11.glEnable(GL_BLEND);
             GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-            if (LightmapHelper.isLightmapEnabled()) { // TODO remove these awful hardcoded fixes
-                Lighting.enableInventoryLight();
-            }
-            BlockModelDispatcher.getInstance().getDispatch(block).renderBlockOnInventory(tessellator, tileEntity.flowerData, lightLevel, lmc);
+            Lighting.disable();
+            BlockModelDispatcher.getInstance().getDispatch(block).renderStandalone(tessellator, tileEntity.flowerData, getBlockBrightness(tileEntity.worldObj, tileEntity.x, tileEntity.y, tileEntity.z), 1f, tileEntity.worldObj.getLightmapCoord(tileEntity.x, tileEntity.y, tileEntity.z, Minecraft.getMinecraft().isFullbrightEnabled() ? 15 : 0));
+            Lighting.enableLight();
             GL11.glDisable(GL_BLEND);
-            if (LightmapHelper.isLightmapEnabled()) { // This one too
-                Lighting.disable();
-            }
         }
         GL11.glPopMatrix();
     }
+
+    public float getBlockBrightness(WorldSource blockAccess, int x, int y, int z)
+    {
+        if (Minecraft.getMinecraft().fullbright || LightmapHelper.isLightmapEnabled()) return 1.0f;
+        return blockAccess.getBrightness(x, y, z, 0);
+    }
 }
\ No newline at end of file
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererJarButterfly.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
similarity index 94%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererJarButterfly.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
index 3d54a0304..3f95b2e7f 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererJarButterfly.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererJarButterfly.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.render.entity.MobRendererButterfly;
 import net.minecraft.client.render.tessellator.Tessellator;
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMeshGold.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
similarity index 51%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMeshGold.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
index 3cac4a5a8..29862758c 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMeshGold.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMeshGold.java
@@ -1,24 +1,17 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
 import net.minecraft.core.block.entity.TileEntityMeshGold;
-import net.minecraft.core.entity.EntityItem;
 import org.lwjgl.opengl.GL11;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.EntityRenderDispatcher;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.item.model.ItemModelDispatcher;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.Global;
 import net.minecraft.core.util.helper.MathHelper;
-import java.util.Random;
 import org.lwjgl.opengl.GL12;
+import org.useless.dragonfly.DisplayPos;
 
 public class TileEntityRendererMeshGold extends TileEntityRenderer<TileEntityMeshGold> {
-	
-	public EntityItem renderEntity = new EntityItem(null);
-
-    private Random rand = new Random();
 
     @Override
     public void doRender(Tessellator tessellator, TileEntityMeshGold tileEntity, double x, double y, double z, float renderPartialTicks) {
@@ -26,25 +19,13 @@ public class TileEntityRendererMeshGold extends TileEntityRenderer<TileEntityMes
         GL11.glPushMatrix();
 
         final float bobbingOffset = MathHelper.sin((tileEntity.ticksRan + renderPartialTicks) / 10F) * 0.1F + 0.1F;
-        final float f3 = (float) Math.toDegrees(((tileEntity.ticksRan + renderPartialTicks) / 20F));
+        final float yaw = (float) Math.toDegrees(((tileEntity.ticksRan + renderPartialTicks) / 20F));
 
         GL11.glTranslatef((float) x + 0.5f, (float) y + bobbingOffset + 0.25f, (float) z + 0.5f);
-        
-        renderEntity.world = tileEntity.worldObj;
-        renderEntity.x = renderEntity.xo = tileEntity.x + 0.5;
-        renderEntity.y = renderEntity.yo = tileEntity.y + 0.5;
-        renderEntity.z = renderEntity.zo = tileEntity.z + 0.5;
-        
+
         float lightLevel = Minecraft.getMinecraft().currentWorld.getLightBrightness(tileEntity.x, tileEntity.y, tileEntity.z);
         if (Global.accessor.isFullbrightEnabled()) lightLevel = 1.0f;
-        BlockModel.setRenderBlocks(EntityRenderDispatcher.instance.itemRenderer.renderBlocksInstance);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
-        GL11.glEnable(GL11.GL_BLEND);
-        ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderAsItemEntity(Tessellator.instance, renderEntity, rand, tileEntity.filterItem, 1, f3, lightLevel, renderPartialTicks);
-        GL11.glDisable(GL11.GL_BLEND);
-        GL11.glDisable(GL12.GL_RESCALE_NORMAL);
+        ItemModelDispatcher.getInstance().getDispatch(tileEntity.filterItem).renderItemEntity(tessellator, tileEntity.filterItem, Minecraft.getMinecraft().gameSettings.items3D.value, 1, tileEntity.ticksRan, yaw, lightLevel, 1f, renderPartialTicks);
         GL11.glPopMatrix();
-        
-        renderEntity.world = null;
     }
 }
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMobSpawner.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
similarity index 97%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMobSpawner.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
index 65c0421d2..90b124037 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMobSpawner.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMobSpawner.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
 import java.util.HashMap;
 import java.util.Map;
diff --git a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
similarity index 58%
rename from game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
rename to game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
index 12cbe6d64..5f981884b 100644
--- a/game/client/src/main/java/net/minecraft/client/render/blockentity/TileEntityRendererMovingPiston.java
+++ b/game/client/src/main/java/net/minecraft/client/render/tileentity/TileEntityRendererMovingPiston.java
@@ -1,10 +1,8 @@
-package net.minecraft.client.render.blockentity;
+package net.minecraft.client.render.tileentity;
 
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.render.BlockEntityRenderDispatcher;
+import net.minecraft.client.render.TileEntityRenderDispatcher;
 import net.minecraft.client.render.Lighting;
-import net.minecraft.client.render.RenderBlocks;
-import net.minecraft.client.render.block.model.BlockModel;
 import net.minecraft.client.render.block.model.BlockModelDispatcher;
 import net.minecraft.client.render.block.model.BlockModelPiston;
 import net.minecraft.client.render.block.model.BlockModelPistonHead;
@@ -17,16 +15,13 @@ import net.minecraft.core.block.piston.BlockLogicPistonBaseSteel;
 import net.minecraft.core.block.piston.BlockLogicPistonHead;
 import net.minecraft.core.block.piston.TileEntityMovingPistonBlock;
 import net.minecraft.core.world.BlocksContainer;
-import net.minecraft.core.world.World;
 import org.lwjgl.opengl.GL11;
 
 public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntityMovingPistonBlock>
 {
-    private RenderBlocks renderBlocks;
     private final Minecraft mc;
 
     private BlocksContainer container = null;
-    private RenderBlocks containerRenderBlock = null;
 
     public TileEntityRendererMovingPiston()
     {
@@ -34,21 +29,14 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
     }
 
     @Override
-	public void onWorldChanged(World world)
-    {
-        renderBlocks = new RenderBlocks(world);
-    }
-
-    @Override
-	public void doRender(Tessellator tessellator, TileEntityMovingPistonBlock blockEntity, double x, double y, double z,
+	public void doRender(Tessellator tessellator, TileEntityMovingPistonBlock tileEntity, double x, double y, double z,
                          float partialTick)
     {
-        Block<?> block = Blocks.getBlock(blockEntity.getMovedId());
-        if(block != null && blockEntity.getProgress(partialTick) < 1.0F)
+        Block<?> block = Blocks.getBlock(tileEntity.getMovedId());
+        if(block != null && tileEntity.getProgress(partialTick) < 1.0F)
         {
-            if (container == null || container.world != blockEntity.worldObj) {
-                container = new BlocksContainer(blockEntity.worldObj);
-                containerRenderBlock = new RenderBlocks(container);
+            if (container == null || container.world != tileEntity.worldObj) {
+                container = new BlocksContainer(tileEntity.worldObj);
             }
             TextureRegistry.blockAtlas.bind();
             Lighting.disable();
@@ -63,34 +51,31 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
                 GL11.glShadeModel(GL11.GL_FLAT);
             }
             tessellator.startDrawingQuads();
-            tessellator.setTranslation(((float)x - (float)blockEntity.x) + blockEntity.getXOff(partialTick), ((float)y - (float)blockEntity.y) + blockEntity.getYOff(partialTick), ((float)z - (float)blockEntity.z) + blockEntity.getZOff(partialTick));
-            if(Block.hasLogicClass(block, BlockLogicPistonHead.class) && blockEntity.getProgress(partialTick) < 0.5F)
+            tessellator.setTranslation(((float)x - (float)tileEntity.x) + tileEntity.getXOff(partialTick), ((float)y - (float)tileEntity.y) + tileEntity.getYOff(partialTick), ((float)z - (float)tileEntity.z) + tileEntity.getZOff(partialTick));
+            if(Block.hasLogicClass(block, BlockLogicPistonHead.class) && tileEntity.getProgress(partialTick) < 0.5F)
             {
-                BlockModel.setRenderBlocks(renderBlocks);
-                ((BlockModelPistonHead)BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, (Block<BlockLogicPistonHead>) block, blockEntity.x, blockEntity.y, blockEntity.z, false);
+                ((BlockModelPistonHead)BlockModelDispatcher.getInstance().getDispatch(block)).renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, (Block<BlockLogicPistonHead>) block, tileEntity.x, tileEntity.y, tileEntity.z, false);
             } else
-            if(blockEntity.isSourcePiston() && !blockEntity.isExtending())
+            if(tileEntity.isSourcePiston() && !tileEntity.isExtending())
             {
                 BlockModelPiston<?> pistonBase = (BlockModelPiston<?>) BlockModelDispatcher.getInstance().getDispatch(block);
-                BlockModel.setRenderBlocks(renderBlocks);
                 if (Block.hasLogicClass(block, BlockLogicPistonBaseSteel.class)) { // Todo remove this terrible hardcoded render code
                     BlockModelPistonHead blockModelPistonHead = ((BlockModelPistonHead) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD_STEEL));
                     blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
-                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, Blocks.PISTON_HEAD_STEEL, blockEntity.x, blockEntity.y, blockEntity.z, blockEntity.getProgress(partialTick) < 0.5F);
+                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, Blocks.PISTON_HEAD_STEEL, tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.getProgress(partialTick) < 0.5F);
                     blockModelPistonHead.setFaceTextureOverride(null);
                 } else {
                     BlockModelPistonHead blockModelPistonHead = ((BlockModelPistonHead) BlockModelDispatcher.getInstance().getDispatch(Blocks.PISTON_HEAD));
                     blockModelPistonHead.setFaceTextureOverride(pistonBase.getFaceTexture());
-                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, Blocks.PISTON_HEAD, blockEntity.x, blockEntity.y, blockEntity.z, blockEntity.getProgress(partialTick) < 0.5F);
+                    blockModelPistonHead.renderPistonHeadNoCulling(tessellator, tileEntity.worldObj, Blocks.PISTON_HEAD, tileEntity.x, tileEntity.y, tileEntity.z, tileEntity.getProgress(partialTick) < 0.5F);
                     blockModelPistonHead.setFaceTextureOverride(null);
                 }
-                tessellator.setTranslation((float)x - (float)blockEntity.x, (float)y - (float)blockEntity.y, (float)z - (float)blockEntity.z);
-                pistonBase.renderHeadless(tessellator, blockEntity.x, blockEntity.y, blockEntity.z);
+                tessellator.setTranslation((float)x - (float)tileEntity.x, (float)y - (float)tileEntity.y, (float)z - (float)tileEntity.z);
+                pistonBase.renderHeadless(tessellator, tileEntity.worldObj, tileEntity.x, tileEntity.y, tileEntity.z);
             } else
             {
-                BlockModel.setRenderBlocks(containerRenderBlock);
-                container.setBlock(blockEntity.x, blockEntity.y, blockEntity.z, block.id(), blockEntity.getMovedData(), blockEntity.getMovedEntity());
-                BlockModelDispatcher.getInstance().getDispatch(block).renderNoCulling(tessellator, blockEntity.x, blockEntity.y, blockEntity.z);
+                container.setBlock(tileEntity.x, tileEntity.y, tileEntity.z, block.id(), tileEntity.getMovedData(), tileEntity.getMovedEntity());
+                BlockModelDispatcher.getInstance().getDispatch(block).renderNoCulling(tessellator, container, tileEntity.x, tileEntity.y, tileEntity.z);
                 container.setLightReferenceEntity(null);
                 container.clear();
             }
@@ -99,11 +84,11 @@ public class TileEntityRendererMovingPiston extends TileEntityRenderer<TileEntit
 
             Lighting.enableLight();
 
-            TileEntity movedEntity = blockEntity.getMovedEntity();
-            TileEntityRenderer<TileEntity> renderer = BlockEntityRenderDispatcher.instance.getRenderer(movedEntity);
+            TileEntity movedEntity = tileEntity.getMovedEntity();
+            TileEntityRenderer<TileEntity> renderer = TileEntityRenderDispatcher.instance.getRenderer(movedEntity);
             if (renderer != null) {
                 GL11.glPushMatrix();
-                GL11.glTranslatef(blockEntity.getXOff(partialTick), blockEntity.getYOff(partialTick), blockEntity.getZOff(partialTick));
+                GL11.glTranslatef(tileEntity.getXOff(partialTick), tileEntity.getYOff(partialTick), tileEntity.getZOff(partialTick));
                 renderer.doRender(tessellator, movedEntity, x, y, z, partialTick);
                 GL11.glPopMatrix();
             }
